/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
var XYChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XYChart, _super);
    function XYChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.wo = null;
        _this.wp = null;
        _this.w5 = 0;
        _this.w7 = 5;
        _this.w6 = 0;
        _this.w4 = 5;
        _this.xm = 5;
        _this.xo = 0;
        _this.xn = 5;
        _this.xl = 0;
        _this.acf = null;
        _this.acm = null;
        _this.acd = null;
        _this.ace = null;
        _this.xg = 0;
        _this.xx = 0;
        _this.xf = NaN;
        _this.xw = NaN;
        _this.xi = NaN;
        _this.xz = NaN;
        _this.xh = NaN;
        _this.xy = NaN;
        _this.xe = NaN;
        _this.xv = NaN;
        _this.acl = null;
        _this.acs = null;
        _this.y7 = null;
        _this.zb = null;
        _this.y9 = null;
        _this.zd = null;
        _this.y2 = null;
        _this.y3 = null;
        _this.acg = null;
        _this.acn = null;
        _this.w8 = DeviceUtils.g(1);
        _this.xp = DeviceUtils.g(1);
        _this.w9 = DeviceUtils.g(1);
        _this.xq = DeviceUtils.g(1);
        _this.aci = null;
        _this.acp = null;
        _this.acj = null;
        _this.acq = null;
        _this.xa = DeviceUtils.g(1);
        _this.xr = DeviceUtils.g(1);
        _this.xb = DeviceUtils.g(8);
        _this.xs = 0;
        _this.ack = null;
        _this.acr = null;
        _this.xc = DeviceUtils.g(1);
        _this.xt = DeviceUtils.g(1);
        _this.y8 = null;
        _this.zc = null;
        _this.ach = null;
        _this.aco = null;
        _this.w3 = 0;
        _this.xk = 0;
        _this.w2 = NaN;
        _this.xj = NaN;
        _this.xd = 0;
        _this.xu = -90;
        _this.wy = false;
        _this.wz = false;
        _this.ab8 = 1;
        _this.adb = 1;
        _this.ab7 = 1;
        _this.ab9 = 2;
        _this.ac9 = 0;
        _this.ada = 1;
        _this.adf = 0;
        _this.adg = 0;
        _this.ww = 4;
        _this.wu = 4;
        _this.y6 = null;
        _this.wi = null;
        _this.za = null;
        _this.wj = null;
        return _this;
    }
    XYChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.wm();
            var c = this.wn();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    XYChart.prototype.sr = function () {
        _super.prototype.sr.call(this);
        var a = this.wm();
        var b = this.wn();
        if (a != null && a.az != null) {
            this.acv = a.az.textColor;
        }
        if (b != null && b.az != null) {
            this.ac2 = b.az.textColor;
        }
        this.ac0 = AxisDefaults.j;
        this.ac7 = AxisDefaults.j;
        this.acw = AxisDefaults.h;
        this.ac3 = AxisDefaults.h;
        this.acz = AxisDefaults.g;
        this.ac6 = AxisDefaults.g;
    };
    XYChart.prototype.th = function (a, b, c) {
        var _this = this;
        _super.prototype.th.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.abz(function (d) { return d.leftMargin = _this.x7; });
                break;
            case "XAxisLabelTopMargin":
                this.abz(function (d) { return d.topMargin = _this.x9; });
                break;
            case "XAxisLabelRightMargin":
                this.abz(function (d) { return d.rightMargin = _this.x8; });
                break;
            case "XAxisLabelBottomMargin":
                this.abz(function (d) { return d.bottomMargin = _this.x6; });
                break;
            case "YAxisLabelLeftMargin":
                this.ab4(function (d) { return d.leftMargin = _this.yo; });
                break;
            case "YAxisLabelTopMargin":
                this.ab4(function (d) { return d.topMargin = _this.yq; });
                break;
            case "YAxisLabelRightMargin":
                this.ab4(function (d) { return d.rightMargin = _this.yp; });
                break;
            case "YAxisLabelBottomMargin":
                this.ab4(function (d) { return d.bottomMargin = _this.yn; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.act = this.vp(this.acv);
                this.acu = this.vp(this.ac2);
                break;
            case "XAxisLabelTextColor":
                this.act = this.vp(this.acv);
                break;
            case "YAxisLabelTextColor":
                this.acu = this.vp(this.ac2);
                break;
            case "ActualXAxisLabelTextColor":
                this.abz(function (d) { return d.textColor = _this.act; });
                break;
            case "ActualYAxisLabelTextColor":
                this.ab4(function (d) { return d.textColor = _this.acu; });
                break;
            case "XAxisTitleMargin":
                this.ab1(function (d) { return d.margin = _this.yi; });
                break;
            case "YAxisTitleMargin":
                this.ab6(function (d) { return d.margin = _this.yz; });
                break;
            case "XAxisTitleLeftMargin":
                this.ab1(function (d) { return d.leftMargin = _this.yh; });
                break;
            case "YAxisTitleLeftMargin":
                this.ab6(function (d) { return d.leftMargin = _this.yy; });
                break;
            case "XAxisTitleTopMargin":
                this.ab1(function (d) { return d.topMargin = _this.yk; });
                break;
            case "YAxisTitleTopMargin":
                this.ab6(function (d) { return d.topMargin = _this.y1; });
                break;
            case "XAxisTitleRightMargin":
                this.ab1(function (d) { return d.rightMargin = _this.yj; });
                break;
            case "YAxisTitleRightMargin":
                this.ab6(function (d) { return d.rightMargin = _this.y0; });
                break;
            case "XAxisTitleBottomMargin":
                this.ab1(function (d) { return d.bottomMargin = _this.yg; });
                break;
            case "YAxisTitleBottomMargin":
                this.ab6(function (d) { return d.bottomMargin = _this.yx; });
                break;
            case "XAxisTitleTextColor":
                this.ab1(function (d) { return d.textColor = _this.ac1; });
                break;
            case "YAxisTitleTextColor":
                this.ab6(function (d) { return d.textColor = _this.ac8; });
                break;
            case "XAxisFormatLabel":
                this.abx(function (d) { return d.au = _this.wq; });
                break;
            case "YAxisFormatLabel":
                this.ab2(function (d) { return d.au = _this.wr; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "wq", {
        get: function () {
            return this.wo;
        },
        set: function (a) {
            var b = this.wq;
            if (a != b) {
                this.wo = a;
                this.te("XAxisFormatLabel", b, this.wq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "wr", {
        get: function () {
            return this.wp;
        },
        set: function (a) {
            var b = this.wr;
            if (a != b) {
                this.wp = a;
                this.te("YAxisFormatLabel", b, this.wr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x7", {
        get: function () {
            return this.w5;
        },
        set: function (a) {
            var b = this.x7;
            if (a != b) {
                this.w5 = a;
                this.te("XAxisLabelLeftMargin", b, this.x7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x9", {
        get: function () {
            return this.w7;
        },
        set: function (a) {
            var b = this.x9;
            if (a != b) {
                this.w7 = a;
                this.te("XAxisLabelTopMargin", b, this.x9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x8", {
        get: function () {
            return this.w6;
        },
        set: function (a) {
            var b = this.x8;
            if (a != b) {
                this.w6 = a;
                this.te("XAxisLabelRightMargin", b, this.x8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x6", {
        get: function () {
            return this.w4;
        },
        set: function (a) {
            var b = this.x6;
            if (a != b) {
                this.w4 = a;
                this.te("XAxisLabelBottomMargin", b, this.x6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yo", {
        get: function () {
            return this.xm;
        },
        set: function (a) {
            var b = this.yo;
            if (a != b) {
                this.xm = a;
                this.te("YAxisLabelLeftMargin", b, this.yo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yq", {
        get: function () {
            return this.xo;
        },
        set: function (a) {
            var b = this.yq;
            if (a != b) {
                this.xo = a;
                this.te("YAxisLabelTopMargin", b, this.yq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yp", {
        get: function () {
            return this.xn;
        },
        set: function (a) {
            var b = this.yp;
            if (a != b) {
                this.xn = a;
                this.te("YAxisLabelRightMargin", b, this.yp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yn", {
        get: function () {
            return this.xl;
        },
        set: function (a) {
            var b = this.yn;
            if (a != b) {
                this.xl = a;
                this.te("YAxisLabelBottomMargin", b, this.yn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acv", {
        get: function () {
            return this.acf;
        },
        set: function (a) {
            var b = this.acv;
            if (a != b) {
                this.acf = a;
                this.te("XAxisLabelTextColor", b, this.acv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac2", {
        get: function () {
            return this.acm;
        },
        set: function (a) {
            var b = this.ac2;
            if (a != b) {
                this.acm = a;
                this.te("YAxisLabelTextColor", b, this.ac2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "act", {
        get: function () {
            return this.acd;
        },
        set: function (a) {
            var b = this.acd;
            if (a != b) {
                this.acd = a;
                this.te("ActualXAxisLabelTextColor", b, this.act);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acu", {
        get: function () {
            return this.ace;
        },
        set: function (a) {
            var b = this.ace;
            if (a != b) {
                this.ace = a;
                this.te("ActualYAxisLabelTextColor", b, this.acu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yi", {
        get: function () {
            return this.xg;
        },
        set: function (a) {
            var b = this.yi;
            if (a != b) {
                this.xg = a;
                this.te("XAxisTitleMargin", b, this.yi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yz", {
        get: function () {
            return this.xx;
        },
        set: function (a) {
            var b = this.yz;
            if (a != b) {
                this.xx = a;
                this.te("YAxisTitleMargin", b, this.yz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yh", {
        get: function () {
            return this.xf;
        },
        set: function (a) {
            var b = this.yh;
            if (a != b) {
                this.xf = a;
                this.te("XAxisTitleLeftMargin", b, this.yh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yy", {
        get: function () {
            return this.xw;
        },
        set: function (a) {
            var b = this.yy;
            if (a != b) {
                this.xw = a;
                this.te("YAxisTitleLeftMargin", b, this.yy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yk", {
        get: function () {
            return this.xi;
        },
        set: function (a) {
            var b = this.yk;
            if (a != b) {
                this.xi = a;
                this.te("XAxisTitleTopMargin", b, this.yk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "y1", {
        get: function () {
            return this.xz;
        },
        set: function (a) {
            var b = this.y1;
            if (a != b) {
                this.xz = a;
                this.te("YAxisTitleTopMargin", b, this.y1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yj", {
        get: function () {
            return this.xh;
        },
        set: function (a) {
            var b = this.yj;
            if (a != b) {
                this.xh = a;
                this.te("XAxisTitleRightMargin", b, this.yj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "y0", {
        get: function () {
            return this.xy;
        },
        set: function (a) {
            var b = this.y0;
            if (a != b) {
                this.xy = a;
                this.te("YAxisTitleRightMargin", b, this.y0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yg", {
        get: function () {
            return this.xe;
        },
        set: function (a) {
            var b = this.yg;
            if (a != b) {
                this.xe = a;
                this.te("XAxisTitleBottomMargin", b, this.yg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yx", {
        get: function () {
            return this.xv;
        },
        set: function (a) {
            var b = this.yx;
            if (a != b) {
                this.xv = a;
                this.te("YAxisTitleBottomMargin", b, this.yx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac1", {
        get: function () {
            return this.acl;
        },
        set: function (a) {
            var b = this.ac1;
            if (a != b) {
                this.acl = a;
                this.te("XAxisTitleTextColor", b, this.ac1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac8", {
        get: function () {
            return this.acs;
        },
        set: function (a) {
            var b = this.ac8;
            if (a != b) {
                this.acs = a;
                this.te("YAxisTitleTextColor", b, this.ac8);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.ti = function (a, b, c) {
        var _this = this;
        _super.prototype.ti.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.abz(function (d) { return d.textStyle = _this.zv; });
                break;
            case "YAxisLabelTextStyle":
                this.ab4(function (d) { return d.textStyle = _this.aa0; });
                break;
            case "XAxisTitleTextStyle":
                this.ab1(function (d) { return d.textStyle = _this.aaj; });
                break;
            case "YAxisTitleTextStyle":
                this.ab6(function (d) { return d.textStyle = _this.abo; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "zv", {
        get: function () {
            return this.y7;
        },
        set: function (a) {
            var b = this.zv;
            if (a != b) {
                this.y7 = a;
                this.te("XAxisLabelTextStyle", b, this.zv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa0", {
        get: function () {
            return this.zb;
        },
        set: function (a) {
            var b = this.aa0;
            if (a != b) {
                this.zb = a;
                this.te("YAxisLabelTextStyle", b, this.aa0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aaj", {
        get: function () {
            return this.y9;
        },
        set: function (a) {
            var b = this.aaj;
            if (a != b) {
                this.y9 = a;
                this.te("XAxisTitleTextStyle", b, this.aaj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abo", {
        get: function () {
            return this.zd;
        },
        set: function (a) {
            var b = this.abo;
            if (a != b) {
                this.zd = a;
                this.te("YAxisTitleTextStyle", b, this.abo);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.abu = function (a) {
        var _this = this;
        this.abr(a, function (b) { return b.leftMargin = _this.x7; });
        this.abr(a, function (b) { return b.topMargin = _this.x9; });
        this.abr(a, function (b) { return b.rightMargin = _this.x8; });
        this.abr(a, function (b) { return b.bottomMargin = _this.x6; });
        this.abr(a, function (b) { return b.textColor = _this.act; });
        this.abs(a, function (b) { return b.textColor = _this.ac1; });
        this.abs(a, function (b) { return b.leftMargin = _this.yh; });
        this.abs(a, function (b) { return b.topMargin = _this.yk; });
        this.abs(a, function (b) { return b.rightMargin = _this.yj; });
        this.abs(a, function (b) { return b.bottomMargin = _this.yg; });
        this.abr(a, function (b) { return b.textStyle = _this.zv; });
        this.abs(a, function (b) { return b.textStyle = _this.aaj; });
    };
    XYChart.prototype.abw = function (a) {
        var _this = this;
        this.abr(a, function (b) { return b.leftMargin = _this.yo; });
        this.abr(a, function (b) { return b.topMargin = _this.yq; });
        this.abr(a, function (b) { return b.rightMargin = _this.yp; });
        this.abr(a, function (b) { return b.bottomMargin = _this.yn; });
        this.abr(a, function (b) { return b.textColor = _this.acu; });
        this.abs(a, function (b) { return b.textColor = _this.ac8; });
        this.abs(a, function (b) { return b.leftMargin = _this.yy; });
        this.abs(a, function (b) { return b.topMargin = _this.y1; });
        this.abs(a, function (b) { return b.rightMargin = _this.y0; });
        this.abs(a, function (b) { return b.bottomMargin = _this.yx; });
        this.abr(a, function (b) { return b.textStyle = _this.aa0; });
        this.abs(a, function (b) { return b.textStyle = _this.abo; });
    };
    XYChart.prototype.tz = function (a) {
        var b = this.bc(a);
        var c = this.c2(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        if (a.highlightedData != null) {
            c.highlightedItemsSource = a.highlightedData;
        }
        c.name = this.or(a);
        c.title = this.os(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.abx = function (a) {
        this.aby(a, null);
    };
    XYChart.prototype.aby = function (a, b) {
        a(this.wm());
    };
    XYChart.prototype.ab3 = function (a, b) {
        a(this.wn());
    };
    XYChart.prototype.ab2 = function (a) {
        this.ab3(a, true);
    };
    XYChart.prototype.sb = function (a, b) {
        this.abx(a);
        this.ab3(a, b);
    };
    XYChart.prototype.ab1 = function (a) {
        this.abs(this.wm(), a);
    };
    XYChart.prototype.ab6 = function (a) {
        this.abs(this.wn(), a);
    };
    XYChart.prototype.ab4 = function (a) {
        this.abr(this.wn(), a);
    };
    XYChart.prototype.abz = function (a) {
        this.abr(this.wm(), a);
    };
    XYChart.prototype.x0 = function (a) {
        var b = this.wm();
        return b.ej(a, new ScalerParams(1, this.vx, this.vw, b.ch));
    };
    XYChart.prototype.x2 = function (a) {
        var b = this.wm();
        return b.em(a, new ScalerParams(1, this.vx, this.vw, b.ch));
    };
    XYChart.prototype.x1 = function (a) {
        var b = this.wn();
        return b.ej(a, new ScalerParams(1, this.vx, this.vw, b.ch));
    };
    XYChart.prototype.x3 = function (a) {
        var b = this.wn();
        return b.em(a, new ScalerParams(1, this.vx, this.vw, b.ch));
    };
    XYChart.prototype.tw = function (a) {
        _super.prototype.tw.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.wm();
            var c = this.wn();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.zg = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    XYChart.prototype.sm = function (a) {
        _super.prototype.sm.call(this, a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.wm());
            this.dataChart.axes.add(this.wn());
        }
    };
    XYChart.prototype.abt = function (a) {
        var _this = this;
        if (a != null && this.kj != null && a.fl == null) {
            a.provideRenderer(this.kj);
        }
        a.jw = this.acw;
        a.er = this.ya;
        a.jx = this.acx;
        a.eu = this.yb;
        a.jz = this.acz;
        a.fg = this.yc;
        a.jy = this.acy;
        a.fh = this.yd;
        a.j0 = this.ac0;
        a.fi = this.ye;
        a.c4 = true;
        a.cu = this.gm;
        a.cw = this.gm;
        var b = a == this.wm();
        if (b) {
            a.g6 = this.aaa;
        }
        a.f0 = this.y4;
        a.gg = this.zm;
        a.ah = this.wk;
        this.abr(a, function (c) { return c.angle = _this.x5; });
        this.abr(a, function (c) {
            if (c.extent != _this.x4) {
                c.extent = _this.x4;
            }
        });
        this.abr(a, function (c) { return c.horizontalAlignment = _this.aca; });
        this.abr(a, function (c) { return c.verticalAlignment = _this.adc; });
        this.abr(a, function (c) { return c.visibility = _this.adh; });
        this.abr(a, function (c) { return c.location = _this.ws(_this.wv); });
        this.abs(a, function (c) { return c.horizontalAlignment = _this.acb; });
        this.abs(a, function (c) { return c.angle = _this.yf; });
        this.abu(a);
    };
    XYChart.prototype.abv = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.kj != null && a.fl == null) {
            a.provideRenderer(this.kj);
        }
        a.cu = this.gm;
        a.cw = this.gm;
        this.abr(a, function (b) { return b.angle = _this.ym; });
        this.abr(a, function (b) {
            if (b.extent != _this.yl) {
                b.extent = _this.yl;
            }
        });
        this.abr(a, function (b) { return b.horizontalAlignment = _this.acc; });
        this.abr(a, function (b) { return b.verticalAlignment = _this.add; });
        this.abr(a, function (b) { return b.visibility = _this.adi; });
        this.abr(a, function (b) { return b.location = _this.wt(_this.wx); });
        this.abs(a, function (b) { return b.verticalAlignment = _this.ade; });
        this.abs(a, function (b) { return b.angle = _this.yw; });
        a.jw = this.ac3;
        a.er = this.yr;
        a.jx = this.ac4;
        a.eu = this.ys;
        a.jz = this.ac6;
        a.fg = this.yt;
        a.jy = this.ac5;
        a.fh = this.yu;
        a.j0 = this.ac7;
        a.fi = this.yv;
        var b = a == this.wn();
        if (b) {
            a.g6 = this.abf;
        }
        a.gg = this.aar;
        a.ah = this.wl;
        this.abw(a);
    };
    XYChart.prototype.sj = function () {
        _super.prototype.sj.call(this);
        this.abt(this.wm());
        this.abv(this.wn());
    };
    XYChart.prototype.abr = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.az == null) {
            a.az = new AxisLabelSettings();
            a.az.angle = a.d5();
            a.az.bottomMargin = a.d6();
            a.az.leftMargin = a.d7();
            a.az.rightMargin = a.d8();
            a.az.topMargin = a.d9();
            a.az.horizontalAlignment = a.jr();
            a.az.location = a.a0();
            a.az.verticalAlignment = a.kk();
        }
        b(a.az);
    };
    XYChart.prototype.abs = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bf == null) {
            a.bf = new TitleSettings();
            a.bf.bottomMargin = a.eb();
            a.bf.leftMargin = a.ec();
            a.bf.rightMargin = a.ed();
            a.bf.topMargin = a.ee();
            a.bf.location = a.a1();
            a.bf.angle = a.ea();
            a.bf.horizontalAlignment = a.js();
            a.bf.verticalAlignment = a.kl();
        }
        b(a.bf);
    };
    XYChart.prototype.te = function (a, b, c) {
        var _this = this;
        _super.prototype.te.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.abz(function (d) { return d.angle = _this.x5; });
                break;
            case "YAxisLabelAngle":
                this.ab4(function (d) { return d.angle = _this.ym; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.abz(function (d) { return d.horizontalAlignment = _this.aca; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.ab4(function (d) { return d.horizontalAlignment = _this.acc; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.abz(function (d) { return d.verticalAlignment = _this.adc; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.ab4(function (d) { return d.verticalAlignment = _this.add; });
                break;
            case "XAxisLabelVisibility":
                this.abz(function (d) { return d.visibility = _this.adh; });
                break;
            case "YAxisLabelVisibility":
                this.ab4(function (d) { return d.visibility = _this.adi; });
                break;
            case "XAxisLabel":
                this.abx(function (d) { return d.f0 = _this.y4; });
                break;
            case "YAxisLabel":
                this.ab2(function (d) { return d.f0 = _this.y5; });
                break;
            case "XAxisLabelFormat":
                this.abx(function (d) { return d.gg = _this.zm; });
                break;
            case "XAxisLabelFormatSpecifiers":
                this.abx(function (d) { return d.ah = _this.wk; });
                break;
            case "YAxisLabelFormat":
                this.ab2(function (d) { return d.gg = _this.aar; });
                break;
            case "YAxisLabelFormatSpecifiers":
                this.ab2(function (d) { return d.ah = _this.wl; });
                break;
            case "XAxisTitleAngle":
                this.ab1(function (d) { return d.angle = _this.yf; });
                break;
            case "YAxisTitleAngle":
                this.ab6(function (d) { return d.angle = _this.yw; });
                break;
            case "XAxisTitleAlignment":
                this.ab1(function (d) { return d.horizontalAlignment = _this.acb; });
                break;
            case "YAxisTitleAlignment":
                this.ab6(function (d) { return d.verticalAlignment = _this.ade; });
                break;
            case "XAxisTitle":
                this.abx(function (d) { return d.g6 = _this.aaa; });
                break;
            case "YAxisTitle":
                this.ab3(function (d) { return d.g6 = _this.abf; }, false);
                break;
            case "XAxisMajorStroke":
                this.aby(function (d) { return d.jw = _this.acw; }, a);
                break;
            case "YAxisMajorStroke":
                this.ab2(function (d) { return d.jw = _this.ac3; });
                break;
            case "XAxisMajorStrokeThickness":
                this.aby(function (d) { return d.er = _this.ya; }, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.ab2(function (d) { return d.er = _this.yr; });
                break;
            case "XAxisMinorStroke":
                this.abx(function (d) { return d.jx = _this.acx; });
                break;
            case "YAxisMinorStroke":
                this.ab2(function (d) { return d.jx = _this.ac4; });
                break;
            case "XAxisMinorStrokeThickness":
                this.abx(function (d) { return d.eu = _this.yb; });
                break;
            case "YAxisMinorStrokeThickness":
                this.ab2(function (d) { return d.eu = _this.ys; });
                break;
            case "XAxisTickLength":
                this.abx(function (d) { return d.fh = _this.yd; });
                break;
            case "YAxisTickLength":
                this.ab2(function (d) { return d.fh = _this.yu; });
                break;
            case "XAxisTickStroke":
                this.abx(function (d) { return d.j0 = _this.ac0; });
                break;
            case "YAxisTickStroke":
                this.ab2(function (d) { return d.j0 = _this.ac7; });
                break;
            case "XAxisTickStrokeThickness":
                this.abx(function (d) { return d.fi = _this.ye; });
                break;
            case "YAxisTickStrokeThickness":
                this.ab2(function (d) { return d.fi = _this.yv; });
                break;
            case "XAxisStroke":
                this.abx(function (d) { return d.jz = _this.acz; });
                break;
            case "YAxisStroke":
                this.ab2(function (d) { return d.jz = _this.ac6; });
                break;
            case "XAxisStrokeThickness":
                this.abx(function (d) { return d.fg = _this.yc; });
                break;
            case "YAxisStrokeThickness":
                this.ab2(function (d) { return d.fg = _this.yt; });
                break;
            case "XAxisExtent":
                this.abz(function (d) { return d.extent = _this.x4; });
                break;
            case "YAxisExtent":
                this.ab4(function (d) { return d.extent = _this.yl; });
                break;
            case "XAxisStrip":
                this.abx(function (d) { return d.jy = _this.acy; });
                break;
            case "YAxisStrip":
                this.ab2(function (d) { return d.jy = _this.ac5; });
                break;
            case "XAxisInverted":
                this.abx(function (d) { return d.ch = _this.w0; });
                break;
            case "YAxisInverted":
                this.ab2(function (d) { return d.ch = _this.w1; });
                break;
            case "YAxisLabelLocation":
                this.ab5();
                break;
            case "XAxisLabelLocation":
                this.ab0();
                break;
        }
    };
    XYChart.prototype.ab5 = function () {
        var a = this.wt(this.wx);
        if (a == 2 || a == 7) {
            this.acc = 2;
        }
        else {
            this.acc = 0;
        }
        this.ab4(function (b) { return b.location = a; });
    };
    XYChart.prototype.ab0 = function () {
        var a = this.ws(this.wv);
        if (a == 1 || a == 5) {
            this.adc = 0;
        }
        else {
            this.adc = 2;
        }
        this.abz(function (b) { return b.location = a; });
    };
    XYChart.prototype.wt = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.b1 == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    XYChart.prototype.ws = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(XYChart.prototype, "y4", {
        get: function () {
            return this.y2;
        },
        set: function (a) {
            var b = this.y4;
            if (a != b) {
                this.y2 = a;
                this.te("XAxisLabel", b, this.y4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "y5", {
        get: function () {
            return this.y3;
        },
        set: function (a) {
            var b = this.y5;
            if (a != b) {
                this.y3 = a;
                this.te("YAxisLabel", b, this.y5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acw", {
        get: function () {
            return this.acg;
        },
        set: function (a) {
            var b = this.acw;
            if (a != b) {
                this.acg = a;
                this.te("XAxisMajorStroke", b, this.acw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac3", {
        get: function () {
            return this.acn;
        },
        set: function (a) {
            var b = this.ac3;
            if (a != b) {
                this.acn = a;
                this.te("YAxisMajorStroke", b, this.ac3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ya", {
        get: function () {
            return this.w8;
        },
        set: function (a) {
            var b = this.ya;
            if (a != b) {
                this.w8 = a;
                this.te("XAxisMajorStrokeThickness", b, this.ya);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yr", {
        get: function () {
            return this.xp;
        },
        set: function (a) {
            var b = this.yr;
            if (a != b) {
                this.xp = a;
                this.te("YAxisMajorStrokeThickness", b, this.yr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yb", {
        get: function () {
            return this.w9;
        },
        set: function (a) {
            var b = this.yb;
            if (a != b) {
                this.w9 = a;
                this.te("XAxisMinorStrokeThickness", b, this.yb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ys", {
        get: function () {
            return this.xq;
        },
        set: function (a) {
            var b = this.ys;
            if (a != b) {
                this.xq = a;
                this.te("YAxisMinorStrokeThickness", b, this.ys);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acy", {
        get: function () {
            return this.aci;
        },
        set: function (a) {
            var b = this.acy;
            if (a != b) {
                this.aci = a;
                this.te("XAxisStrip", b, this.acy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac5", {
        get: function () {
            return this.acp;
        },
        set: function (a) {
            var b = this.ac5;
            if (a != b) {
                this.acp = a;
                this.te("YAxisStrip", b, this.ac5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acz", {
        get: function () {
            return this.acj;
        },
        set: function (a) {
            var b = this.acz;
            if (a != b) {
                this.acj = a;
                this.te("XAxisStroke", b, this.acz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac6", {
        get: function () {
            return this.acq;
        },
        set: function (a) {
            var b = this.ac6;
            if (a != b) {
                this.acq = a;
                this.te("YAxisStroke", b, this.ac6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yc", {
        get: function () {
            return this.xa;
        },
        set: function (a) {
            var b = this.yc;
            if (a != b) {
                this.xa = a;
                this.te("XAxisStrokeThickness", b, this.yc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yt", {
        get: function () {
            return this.xr;
        },
        set: function (a) {
            var b = this.yt;
            if (a != b) {
                this.xr = a;
                this.te("YAxisStrokeThickness", b, this.yt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yd", {
        get: function () {
            return this.xb;
        },
        set: function (a) {
            var b = this.yd;
            if (a != b) {
                this.xb = a;
                this.te("XAxisTickLength", b, this.yd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yu", {
        get: function () {
            return this.xs;
        },
        set: function (a) {
            var b = this.yu;
            if (a != b) {
                this.xs = a;
                this.te("YAxisTickLength", b, this.yu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac0", {
        get: function () {
            return this.ack;
        },
        set: function (a) {
            var b = this.ac0;
            if (a != b) {
                this.ack = a;
                this.te("XAxisTickStroke", b, this.ac0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac7", {
        get: function () {
            return this.acr;
        },
        set: function (a) {
            var b = this.ac7;
            if (a != b) {
                this.acr = a;
                this.te("YAxisTickStroke", b, this.ac7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ye", {
        get: function () {
            return this.xc;
        },
        set: function (a) {
            var b = this.ye;
            if (a != b) {
                this.xc = a;
                this.te("XAxisTickStrokeThickness", b, this.ye);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yv", {
        get: function () {
            return this.xt;
        },
        set: function (a) {
            var b = this.yv;
            if (a != b) {
                this.xt = a;
                this.te("YAxisTickStrokeThickness", b, this.yv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aaa", {
        get: function () {
            return this.y8;
        },
        set: function (a) {
            var b = this.aaa;
            if (a != b) {
                this.y8 = a;
                this.te("XAxisTitle", b, this.aaa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abf", {
        get: function () {
            return this.zc;
        },
        set: function (a) {
            var b = this.abf;
            if (a != b) {
                this.zc = a;
                this.te("YAxisTitle", b, this.abf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acx", {
        get: function () {
            return this.ach;
        },
        set: function (a) {
            var b = this.acx;
            if (a != b) {
                this.ach = a;
                this.te("XAxisMinorStroke", b, this.acx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac4", {
        get: function () {
            return this.aco;
        },
        set: function (a) {
            var b = this.ac4;
            if (a != b) {
                this.aco = a;
                this.te("YAxisMinorStroke", b, this.ac4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x5", {
        get: function () {
            return this.w3;
        },
        set: function (a) {
            var b = this.x5;
            if (a != b) {
                this.w3 = a;
                this.te("XAxisLabelAngle", b, this.x5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ym", {
        get: function () {
            return this.xk;
        },
        set: function (a) {
            var b = this.ym;
            if (a != b) {
                this.xk = a;
                this.te("YAxisLabelAngle", b, this.ym);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x4", {
        get: function () {
            return this.w2;
        },
        set: function (a) {
            var b = this.x4;
            if (a != b) {
                this.w2 = a;
                this.te("XAxisExtent", b, this.x4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yl", {
        get: function () {
            return this.xj;
        },
        set: function (a) {
            var b = this.yl;
            if (a != b) {
                this.xj = a;
                this.te("YAxisExtent", b, this.yl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yf", {
        get: function () {
            return this.xd;
        },
        set: function (a) {
            var b = this.yf;
            if (a != b) {
                this.xd = a;
                this.te("XAxisTitleAngle", b, this.yf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yw", {
        get: function () {
            return this.xu;
        },
        set: function (a) {
            var b = this.yw;
            if (a != b) {
                this.xu = a;
                this.te("YAxisTitleAngle", b, this.yw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w0", {
        get: function () {
            return this.wy;
        },
        set: function (a) {
            var b = this.w0;
            if (a != b) {
                this.wy = a;
                this.te("XAxisInverted", b, this.w0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w1", {
        get: function () {
            return this.wz;
        },
        set: function (a) {
            var b = this.w1;
            if (a != b) {
                this.wz = a;
                this.te("YAxisInverted", b, this.w1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acb", {
        get: function () {
            return this.ab8;
        },
        set: function (a) {
            var b = this.acb;
            if (a != b) {
                this.ab8 = a;
                this.te("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.acb));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ade", {
        get: function () {
            return this.adb;
        },
        set: function (a) {
            var b = this.ade;
            if (a != b) {
                this.adb = a;
                this.te("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ade));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aca", {
        get: function () {
            return this.ab7;
        },
        set: function (a) {
            var b = this.aca;
            if (a != b) {
                this.ab7 = a;
                this.te("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.aca));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_acc = function () {
        return this.ab9;
    };
    XYChart.prototype.set_acc = function (a) {
        var b = this.acc;
        if (a != b) {
            this.ab9 = a;
            this.te("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.acc));
        }
    };
    Object.defineProperty(XYChart.prototype, "acc", {
        get: function () {
            return this.get_acc();
        },
        set: function (a) {
            this.set_acc(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adc", {
        get: function () {
            return this.ac9;
        },
        set: function (a) {
            var b = this.adc;
            if (a != b) {
                this.ac9 = a;
                this.te("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.adc));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "add", {
        get: function () {
            return this.ada;
        },
        set: function (a) {
            var b = this.add;
            if (a != b) {
                this.ada = a;
                this.te("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.add));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adh", {
        get: function () {
            return this.adf;
        },
        set: function (a) {
            var b = this.adh;
            if (a != b) {
                this.adf = a;
                this.te("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.adh));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "adi", {
        get: function () {
            return this.adg;
        },
        set: function (a) {
            var b = this.adi;
            if (a != b) {
                this.adg = a;
                this.te("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.adi));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_wx = function () {
        return this.ww;
    };
    XYChart.prototype.set_wx = function (a) {
        var b = this.wx;
        if (a != b) {
            this.ww = a;
            this.te("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.wx));
        }
    };
    Object.defineProperty(XYChart.prototype, "wx", {
        get: function () {
            return this.get_wx();
        },
        set: function (a) {
            this.set_wx(a);
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_wv = function () {
        return this.wu;
    };
    XYChart.prototype.set_wv = function (a) {
        var b = this.wv;
        if (a != b) {
            this.wu = a;
            this.te("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.wv));
        }
    };
    Object.defineProperty(XYChart.prototype, "wv", {
        get: function () {
            return this.get_wv();
        },
        set: function (a) {
            this.set_wv(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zm", {
        get: function () {
            return this.y6;
        },
        set: function (a) {
            var b = this.y6;
            if (a != b) {
                this.y6 = a;
                this.te("XAxisLabelFormat", b, this.y6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "wk", {
        get: function () {
            return this.wi;
        },
        set: function (a) {
            var b = this.wi;
            if (a != b) {
                this.wi = a;
                this.te("XAxisLabelFormatSpecifiers", b, this.wi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aar", {
        get: function () {
            return this.za;
        },
        set: function (a) {
            var b = this.za;
            if (a != b) {
                this.za = a;
                this.te("YAxisLabelFormat", b, this.za);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "wl", {
        get: function () {
            return this.wj;
        },
        set: function (a) {
            var b = this.wj;
            if (a != b) {
                this.wj = a;
                this.te("YAxisLabelFormatSpecifiers", b, this.wj);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));
export { XYChart };
